/*
 # Fish & Shark
 # Copyright (C) 2012 Sebastian Rothe & Alexander Lambertz
 #
 # This program is free software; you can redistribute it and/or modify it under the terms of the GNU General
 # Public License as published by the Free Software Foundation; either version 3 of the License, or (at your
 # option) any later version.
 #
 # This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the
 # implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License
 # for more details.
 #
 # You should have received a copy of the GNU General Public License along with this program;
 # if not, see <http://www.gnu.org/licenses/>.
*/

#include <dirent.h> 
#include <stdlib.h>
#include <stdio.h>
#include <string.h>

#include <time.h>

#ifndef sequent_debug_h
#define sequent_debug_h

// -----
// Constant to define the way the Output-File looks like
// 1 => ";" seperated list (Without "0")
// 2 => <place>:<value;<place>:<value;
// -----
const int iOutputFormat = 2;


void printArray(int*** array, int y, int x) {
    for (int i=0; i<y; i++) {
        printf("%d##",i);
        for (int j=0; j<x; j++) {
            printf("|%d|",array[i][j][0]);
        }
        printf("| \n");
    }
    printf("\n");
}

void writeArray(int iAmount, int iProcess, int*** array, int y, int x, int noProcesses) {
    
    // Build File-Name
    char buffer2 [255];
    
    int iFirstValue=0;
    
    sprintf(buffer2,"/Users/Alexander 1/Downloads/FishShark/%03i-%03i.txt",iAmount,iProcess);
    //sprintf(buffer2,"/home/lambertz/FishShark/data/%03i-%03i.txt",iAmount,iProcess);
    
    FILE *file; 
    file = fopen(buffer2,"a");
    
    fprintf(file,"NoProcesses:%d,Y:%d,X:%d;\n", noProcesses, y, x);
    
    if (iOutputFormat == 1)
    {
        for (int i=0; i<y; i++) {
            if (i!=0)
                fprintf(file,"\n");
            for (int j=0; j<x; j++) {
                if (array[i][j][0]==0)
                    fprintf(file,";");
                else
                    fprintf(file,"%d;",array[i][j][0]);
            }
        }
    } else if (iOutputFormat == 2) {
        for (int i=0; i<y; i++) {
            if (i!=0)
                fprintf(file,"\n");
            for (int j=0; j<x; j++) {
                if (array[i][j][0]!=0)
                {
                    if (iFirstValue == 0)
                    {
                        fprintf(file,"%d:%d", j, array[i][j][0]);
                        iFirstValue=1;
                    } else {
                        fprintf(file,",%d:%d", j, array[i][j][0]);
                    }
                }
            }
            fprintf(file,";");
            iFirstValue=0;
        }
    }
    
    fprintf(file,"\n");
    
    //fprintf(file,"\n\n");
    fclose(file);
}

void addToOutput(int iAmount, int iProcess, int x, int y, int value)
{
    // Build File-Name
    char buffer2 [255];
    
    sprintf(buffer2,"/Users/Alexander 1/Downloads/FishShark/%03i-%03i.txt",iAmount,iProcess);
    //sprintf(buffer2,"/home/lambertz/FishShark/data/%03i-%03i.txt",iAmount,iProcess);
    
    
    FILE *file;
    file = fopen(buffer2,"a");
    
    fprintf(file,"%d,%d:%d;", x, y, value);
    
    fclose(file);
    
}

void writeTimeToOutput(int iProcess, clock_t beginn, clock_t end)
{
    FILE *file; 
    char filename [255];
    //sprintf(filename,"/home/lambertz/FishShark/TimePrint.txt");
    sprintf(filename,"/Users/Alexander 1/Downloads/FishShark/TimePrint.txt");
    
    file = fopen(filename,"a");
    fprintf(file,"%d : Time (Seconds): %.2f Seconds \n", iProcess, (float)(end-beginn) / CLOCKS_PER_SEC);
    fclose(file);
}



#endif
